//                      Подключаем библиотеки:                                  //
#include                <Servo.h>                                               //  Подключаем библиотеку Servo                   для работы с сервоприводами
#include                <iarduino_HC_SR04_int.h>                                //  Подключаем библиотеку iarduino_HC_SR04_int    для работы с ультразвуковым датчиком HC-SR04+  (ссылка на библиотеку: http://iarduino.ru/file/283.html).
#include                <iarduino_Bluetooth_HC05.h>                             //  Подключаем библиотеку iarduino_Bluetooth_HC05 для работы с Trema Bluetooth модулем HC-05     (ссылка на библиотеку: http://iarduino.ru/file/301.html).
//                      Определяем номера выводов:                              //
const uint8_t           pinEcho       = 2;                                      //  Определяем константу с номером вывода подключённым к выводу Echo датчика расстояний    (можно указывать только те выводы Arduino, которые могут работать с внешними прерываниями)
const uint8_t           pinTrig       = 3;                                      //  Определяем константу с номером вывода подключённым к выводу Trig датчика расстояний    (может быть любым)
const uint8_t           pinLeftTop    = 4;                                      //  Определяем константу с номером вывода подключённым к верхнему сервоприводу левой  ноги (может быть любым)
const uint8_t           pinRightTop   = 5;                                      //  Определяем константу с номером вывода подключённым к верхнему сервоприводу правой ноги (может быть любым)
const uint8_t           pinLeftBot    = 6;                                      //  Определяем константу с номером вывода подключённым к нижнему  сервоприводу левой  ноги (может быть любым)
const uint8_t           pinRightBot   = 7;                                      //  Определяем константу с номером вывода подключённым к нижнему  сервоприводу правой ноги (может быть любым)
const uint8_t           pinKey        = 9;                                      //  Определяем константу с номером вывода подключённым к кнопке                            (может быть любым)
const uint8_t           pinBTKey      = 10;                                     //  Определяем константу с номером вывода подключённым к выводу K модуля bluetooth         (может быть любым)
//                      Определяем константы:                                   //
const uint8_t           cenLeftTop    = 100;                                    //  Определяем константу центрального угла в градусах  для верхнего сервопривода левой  ноги (по умолчанию = 100)
const uint8_t           cenRightTop   = 80;                                     //  Определяем константу центрального угла в градусах  для верхнего сервопривода правой ноги (по умолчанию = 80 )
const uint8_t           cenLeftBot    = 60;                                     //  Определяем константу центрального угла в градусах  для нижнего  сервопривода левой  ноги (по умолчанию = 60 )
const uint8_t           cenRightBot   = 120;                                    //  Определяем константу центрального угла в градусах  для нижнего  сервопривода правой ноги (по умолчанию = 120)
const uint8_t           maxStepSize   = 15;                                     //  Определяем константу максимального размера шага в градусах поворота верхних сервоприводов (чем больше угол, тем шире шаг)
const uint8_t           maxStepHeight = 10;                                     //  Определяем константу максимальной  высоты  шага в градусах наклона в стороны при ходьбе (чем больше угол, тем выше шаг)
const uint32_t          maxSpeed      = 1000;                                   //  Определяем константу максимальной  скорости, она хранит значение задержки в мкс, чем меньше это значение, тем выше максимальная скорость
const uint32_t          minSpeed      = 10000;                                  //  Определяем константу минимальной   скорости, она хранит значение задержки в мкс, чем больше это значение, тем ниже минимальная  скорость
const uint8_t           minDistance   = 10;                                     //  Определяем константу минимального  расстояния в см, при котором робот должен остановиться
//                      Создаём объекты:                                        //
iarduino_HC_SR04_int    objSensor(pinTrig, pinEcho);                            //  Создаём объект sensor        для работы с датчиком расстояний, указывая номера выводов Trig и Echo
iarduino_Bluetooth_HC05 objHC05(pinBTKey);                                      //  Создаём объект objHC05       для работы с модулем bluetooth, указывая вывод K модуля
Servo                   objServoLeftTop;                                        //  Создаём объект servoLeftTop  для работы с верхним левым  сервоприводом
Servo                   objServoRightTop;                                       //  Создаём объект servoRightTop для работы с верхним правым сервоприводом
Servo                   objServoLeftBot;                                        //  Создаём объект servoLeftBot  для работы с нижним  левым  сервоприводом
Servo                   objServoRightBot;                                       //  Создаём объект servoRightBot для работы с нижним  правым сервоприводом
//                      Создаём переменные:                                     //
uint8_t                 valPosition   = 224;                                    //  Определяем переменную (движение) для хранения текущей позиции шага (счёт от 0 до 255 или обратно), начальная позиция 224
 int8_t                 valTurning    = 0;                                      //  Определяем переменную (поворот ) для пересчета размера шага в градусах поворота верхних сервоприводов (-10 - влево ... 0 - прямо ... +10 вправо)
uint8_t                 maxLeftSize   = maxStepSize;                            //  Определяем переменную максимального размера шага в градусах поворота верхнего левого  сервопривода (чем меньше угол, тем сильнее робот будет уходить вправо)
uint8_t                 maxRightSize  = maxStepSize;                            //  Определяем переменную максимального размера шага в градусах поворота верхнего правого сервопривода (чем меньше угол, тем сильнее робот будет уходить влево )
bool                    flgPult       = false;                                  //  Определяем флаг запрещающий чтение данных с пульта более 1 раза за отведённое время
bool                    flgPosition   = false;                                  //  Определяем флаг запрещающий изменение позиции шага более 1 раза за отведённое время
uint32_t                valSpeed      = minSpeed;                               //  Определяем переменную скорости (это задержка изменения позиции шага в мкс, чем меньше значение, тем выше скорость)
//                      Создаём переменные получения данных с пульта:           // 
uint8_t                 sumPultErr    = 20;                                     //  Определяем переменную для подсчёта количества ошибок чтения данных с пульта
int8_t                  arrData[3];                                             //  Объявляем  массив arrData значения которого будут обновляться по bluetooth, можно создавать массивы или переменные любых типов в т.ч. и char
                                                                                //
void setup(){                                                                   //
//  Настраиваем работу с Trema Bluetooth модулем                                //
    pinMode(pinKey, INPUT);                                                     //  Переводим вывод pinKey (кнопка сопряжения) в режим входа
    while(!objHC05.begin(Serial)) {;}                                           //  Инициируем работу с bluetooth модулем, указывая имя объекта или класса для управления шиной UART. При провале инициализации функция begin() вернёт false и тогда оператор while запустит её вновь.
    while(!objHC05.checkConnect()){                                             //  Проверка подключения к внешнему Bluetooth устройству, до тех пор пока связь не будет установлена...
        if(digitalRead(pinKey)){                                                //  Во время проверки наблюдаем не нажата ли кнопка сопряжения, если нажата, то ...
            objHC05.createSlave("Droidik","1234");                              //  Назначаем Bluetooth модулю роль ведомого с именем "Droidik" и PIN-кодом "1234"
            while(digitalRead(pinKey)){;}                                       //  Ждём пока кнопка сопряжения не будет отпущена
        }   delay(1000);                                                        //  Устанавливаем задержку на 1 секунду
    }                                                                           //
//  Настраиваем работу с датчиком расстояния:                                   //
    objSensor.averaging=50;                                                     //  Устанавливаем коэффициент усреднения показаний датчика (0-без усреднений, 1-минимальное усреднение, ... 50-высокое усреднение, ...)
}                                                                               //
void loop(){                                                                    //
//  ==========================================================================  //
//  Получаем данные с пульта в массив arrData:                                  //
    if(millis()%50<5){                                                          //  Каждые 50 мс в течении первых 5 мс ...
        if(flgPult){                                                            //  Если установлен флаг «flgPult» ...
            if( objHC05.available()){                                           //  Если есть принятые данные ...
                objHC05.read(arrData);                                          //  Читаем полученные данные в массив arrData
                sumPultErr=0;                                                   //  Сбрасываем счётчик ошибок при получении данных с пульта
            }else{if(sumPultErr<20){sumPultErr++;}}                             //  Если нет принятых данных, то увеличиваем счётчик ошибок пульта sumPultErr
        flgPult=false;}                                                         //  Сбрасываем флаг «flgPult», чтоб чтение данных выполнилось только один раз за отведённые 5 мс
    }else{flgPult=true;}                                                        //  Если первые 5 мс из очередных 50 мс прошли, то устанавливаем флаг «flgPult» разрешая прочитать новые данные в следующие 50 мс.
//  ==========================================================================  //
//  Читаем показания с датчика расстояния:                                      //
    if(objSensor.distance()<=minDistance){                                      //  Если обнаружено препятствие (реальное расстояние до объекта возвращённое функцией sensor.distance() меньше чем указано в константе minDistance), то ...
        if(arrData[1]>=0){                                                      //  Если джойстик не отклонен назад, то ...
           arrData[1]=0;                                                        //  Запрещаем роботу идти вперёд.
           arrData[0]=0;                                                        //  Запрещаем роботу разворачиваться на месте.
        }                                                                       //  Роботу остаётся только идти назад (с заворотом или без).
    }                                                                           //
//  ==========================================================================  //
//  Меняем значения переменных valPosition, valTurning и valSpeed:              //  Назначение переменных valPosition и valTurning подробно описано ниже, в разделе «Шагаем». А переменная valSpeed определяет скорость с которой эти переменные меняются.
    if(micros()%valSpeed<500){                                                  //  Каждые valSpeed мкс в течении первых 500 мкс ...
    if(flgPosition){                                                            //  Если установлен флаг «flgPosition» ...
//      Если джойстик отклонён вперёд или назад:                                //  
        if(arrData[1]!=0){                                                      //  Если джойстик отклонён вперёд arrData[1]>0 или назад arrData[1]<0, то ...
            valSpeed = map(abs(arrData[1]), 0, 100, minSpeed, maxSpeed);        //  Присваиваем переменной valSpeed задержку в мкс пропорционально отклонению джойстика arrData[1] вперёд или назад.
            valTurning = arrData[0]/10;                                         //  Присваиваем переменной valTurning значение поворота от -10 до +10 пропорционально отклонению джойстика arrData[0] влево или вправо.
            if(arrData[1]>0){valPosition++;}                                    //  Если джойстик отклонён вперёд arrData[1]>0, то увеличиваем позицию походки varPosition.
            else            {valPosition--;}                                    //  Если джойстик отклонён назад  arrData[1]<0, то уменьшаем   позицию походки varPosition.
//      Если джойстик отклонён только влево или вправо:                         //
        }else if(arrData[0]!=0){                                                //  Иначе (если джойстик не отклонён вперёд или назад), но отклонён влево arrData[0]<0 или вправо arrData[0]>0, то ...
            valSpeed = map(abs(arrData[0]), 0, 100, minSpeed, maxSpeed);        //  Присваиваем переменной valSpeed задержку в мкс пропорционально отклонению джойстика arrData[0] влево или вправо.
            valPosition++;                                                      //  Увеличиваем позицию походки.
            if(arrData[0]>0){valTurning= 10;}                                   //  Если джойстик отклонён вправо arrData[0]>0, то присваиваем переменной valTurning максимальное значение = 10.
            else            {valTurning=-10;}                                   //  Если джойстик отклонён влево  arrData[0]<0, то присваиваем переменной valTurning минимальное значение = -10.
//      Стоим на месте:                                                         //
        }else{                                                                  //  Иначе (если джойстик не отклонён вперёд или назад, или влево, или вправо), то ...
            /* Тут можно прописать действия   */                                //
            /* которые будут выполняться если */                                //
            /* джойстик пульта не отклонён    */                                //
        }                                                                       //
        flgPosition=false;                                                      //  Сбрасываем флаг «flgPosition», чтоб чтение данных выполнилось только один раз за отведённые 500 мкс.
    }}else{flgPosition=true;}                                                   //  Если первые 500 мкс из очередных valSpeed мкс прошли, то устанавливаем флаг «flgPosition» разрешая прочитать новые данные в следующие valSpeed мкс.
//  ==========================================================================  //
//  Установка сервоприводов в требуемые позиции (Шагаем):                       //
//  Движение осуществляется в соответствии со значениями переменных valPosition и valTurning.
//  Если значение переменной valPosition приращается, то робот будет идти вперёд. Если значение переменной valPosition убывает, то робот будет идти назад. Чем быстрее выполняется приращение/убавление переменной valPosition, тем быстрее шагает робот.
//  Значение переменной valTurning управляет поворотом робота, 0-прямо, 1-прямо и чуть правее, (чем выше значение - тем круче поворот), 10 поворот вправо на месте. Отрицательные значения переменной valTurning действуют аналогично положительным, но поворот осуществляется влево.
//  Полный шаг каждой ноги разбит на 4 сектора в соответствии со значением переменной valPosition. Каждая нога последовательно выполняет определённое движение для каждого сектора: вверх, вперёд, вниз, назад.
//  Если получены данные о нажатии на джойстик arrData[2], то все суставы ног установятся в центральные положения.
    if(sumPultErr<20){                                                                                                                                //  Если данные с пульта приходят, то ...
        if(!objServoLeftTop. attached()){objServoLeftTop. attach(pinLeftTop );}                                                                       //  Указываем объекту servoLeftTop  работать с выводом pinLeftTop,  если он об этом не знает.
        if(!objServoRightTop.attached()){objServoRightTop.attach(pinRightTop);}                                                                       //  Указываем объекту servoRightTop работать с выводом pinRightTop, если он об этом не знает.
        if(!objServoLeftBot. attached()){objServoLeftBot. attach(pinLeftBot );}                                                                       //  Указываем объекту servoLeftBot  работать с выводом pinLeftBot,  если он об этом не знает.
        if(!objServoRightBot.attached()){objServoRightBot.attach(pinRightBot);}                                                                       //  Указываем объекту servoRightBot работать с выводом pinRightBot, если он об этом не знает.
                                                                                                                                                      //
        maxRightSize=maxStepSize; if(valTurning<0){maxRightSize=map(valTurning, 0,-10, maxStepSize, 0);} /* Прямо или влево  */                       //  Корректируем значение maxRightSize (размера шага правой ноги) в соответствии со значением valTurning.
        maxLeftSize =maxStepSize; if(valTurning>0){maxLeftSize =map(valTurning, 0, 10, maxStepSize, 0);} /* Прямо или вправо */                       //  Корректируем значение maxLeftSize  (размера шага левой  ноги) в соответствии со значением valTurning.
                                                                                                                                                      //
        if(arrData[2])     {objServoLeftTop. write(                           cenLeftTop                                                      );      //  Левая  нога поворачивается в центр.
                            objServoRightTop.write(                           cenRightTop                                                     );      //  Правая нога поворачивается в центр.
                            objServoLeftBot. write(                           cenLeftBot                                                      );      //  Левая  нога наклоняется    в центр.
                            objServoRightBot.write(                           cenRightBot                                                     );}else //  Правая нога наклоняется    в центр.
        if(valPosition<64 ){objServoLeftTop. write(map(valPosition,   0,  63, cenLeftTop  - maxLeftSize      , cenLeftTop  + maxLeftSize     ));      //  Левая  нога поворачивается вправо => отходит    назад.
                            objServoRightTop.write(map(valPosition,   0,  63, cenRightTop - maxRightSize     , cenRightTop + maxRightSize    ));}else //  Правая нога поворачивается вправо => выходит    вперёд.
        if(valPosition<128){objServoLeftBot. write(map(valPosition,  64, 127, cenLeftBot  - maxStepHeight    , cenLeftBot  +(maxStepHeight/2)));      //  Левая  нога наклоняется    вправо => переносит  центр тяжести с себя на правую ногу, которая станет опорной.
                            objServoRightBot.write(map(valPosition,  64, 127, cenRightBot -(maxStepHeight/2) , cenRightBot + maxStepHeight   ));}else //  Правая нога наклоняется    вправо => опускается вниз (становится опорной) и поднимает левую ногу.
        if(valPosition<192){objServoLeftTop. write(map(valPosition, 128, 191, cenLeftTop  + maxLeftSize      , cenLeftTop  - maxLeftSize     ));      //  Левая  нога поворачивается влево  => выходит    вперёд.
                            objServoRightTop.write(map(valPosition, 128, 191, cenRightTop + maxRightSize     , cenRightTop - maxRightSize    ));}else //  Правая нога поворачивается влево  => отходит    назад.
        /*valPosition<255*/{objServoLeftBot. write(map(valPosition, 192, 255, cenLeftBot  +(maxStepHeight/2) , cenLeftBot  - maxStepHeight   ));      //  Левая  нога наклоняется    влево  => опускается вниз (становится опорной) и поднимает правую ногу.
                            objServoRightBot.write(map(valPosition, 192, 255, cenRightBot + maxStepHeight    , cenRightBot -(maxStepHeight/2)));}     //  Правая нога наклоняется    влево  => переносит  центр тяжести с себя на левую ногу, которая станет опорной.
//  ========================================================================== //
//  Разрыв связи с пультом:                                                    //
    }else{                                                                     //  Если данные с пульта не приходят, то ...
        objServoLeftTop. detach(); digitalWrite(pinLeftTop,  LOW);             //  Разрываем связь объекта servoLeftTop  с выводом pinLeftTop  и устанавливаем на этом выводе уровень логического 0.
        objServoRightTop.detach(); digitalWrite(pinRightTop, LOW);             //  Разрываем связь объекта servoRightTop с выводом pinRightTop и устанавливаем на этом выводе уровень логического 0.
        objServoLeftBot. detach(); digitalWrite(pinLeftBot,  LOW);             //  Разрываем связь объекта servoLeftBot  с выводом pinLeftBot  и устанавливаем на этом выводе уровень логического 0.
        objServoRightBot.detach(); digitalWrite(pinRightBot, LOW);             //  Разрываем связь объекта servoRightBot с выводом pinRightBot и устанавливаем на этом выводе уровень логического 0.
    }                                                                          //
//  ========================================================================== //
//  Режим сопряжения:                                                          //
    if(digitalRead(pinKey)){                                                   //  Проверяем не нажата ли кнопка сопряжения, если нажата, то ...
        objHC05.createSlave("Droidik","1234");                                 //  Назначаем Bluetooth модулю роль ведомого с именем "Droidik" и PIN-кодом "1234".
        while(digitalRead(pinKey)){;}                                          //  Ждём пока кнопка сопряжения не будет отпущена.
    }                                                                          //  Программа продолжит выполняться, но Дройдик никуда не пойдёт, так как модуль не сможет получать новые данные пока мастер не установит с ним соединение.
}                                                                              //
